/* Code generated by Engee
 * Model name: mik32_fuzzy_reg.engee
 * Code generator: release-1.1.6
 * Date: Thu Dec  5 14:03:57 2024
 */

#include "stdint.h"
#include "math.h"
#include "mik32_hal.h"
#include "mik32_hal_dac.h"
#include "mik32_dac12_typedef.h"
#include "mik32_fuzzy_reg.h"

/* Block states */
Ext_mik32_fuzzy_reg_S mik32_fuzzy_reg_S;

typedef struct systemClockConfig_cfunc_symbols_t {
	uint8_t seq_out1;
} systemClockConfig_cfunc_symbols_t;

static void systemClockConfig_cfunc_init() {
	/* Этот код вызывается один раз при инициализации модели */
	#ifdef MIK32V2
	    // Инициализация библиотеки HAL
	    HAL_Init();
	    
	    // Настройка подсистемы тактирования и монитора частоты МК
	    PCC_InitTypeDef PCC_OscInit = {0};
	    PCC_OscInit.OscillatorEnable = PCC_OSCILLATORTYPE_ALL;
	    PCC_OscInit.FreqMon.OscillatorSystem = PCC_OSCILLATORTYPE_OSC32M;
	    PCC_OscInit.FreqMon.ForceOscSys = PCC_FORCE_OSC_SYS_UNFIXED;
	    PCC_OscInit.FreqMon.Force32KClk = PCC_FREQ_MONITOR_SOURCE_OSC32K;
	    PCC_OscInit.AHBDivider = 0;
	    PCC_OscInit.APBMDivider = 0;
	    PCC_OscInit.APBPDivider = 0;
	    PCC_OscInit.HSI32MCalibrationValue = 128;
	    PCC_OscInit.LSI32KCalibrationValue = 128;
	    PCC_OscInit.RTCClockSelection = PCC_RTC_CLOCK_SOURCE_AUTO;
	    PCC_OscInit.RTCClockCPUSelection = PCC_CPU_RTC_CLOCK_SOURCE_OSC32K;
	
	    // Структура с состояниями ошибок
	    HAL_PCC_Config(&PCC_OscInit);
	#else
	#endif
}
static void systemClockConfig_cfunc(systemClockConfig_cfunc_symbols_t * cfunc_symbols) {
	uint8_t seq_out1;
	/* Этот код вызывается на каждом шаге расчета модели */
	#ifdef MIK32V2
	#else
	#endif
	cfunc_symbols->seq_out1 = seq_out1;
}

static void systemClockConfig_cfunc_term() {
	/* Этот код вызывается один раз при остановке модели */
	#ifdef MIK32V2
	#else
	#endif
}
typedef struct DAC12_cfunc_symbols_t {
	uint8_t seq_in1_1;
	uint16_t dac_value;
} DAC12_cfunc_symbols_t;

static void DAC12_cfunc_init() {
	/* Этот код вызывается один раз при инициализации модели */
	#ifdef MIK32V2
	    hdac12.Instance = ANALOG_REG;
	
	    hdac12.Instance_dac = HAL_DAC1;
	    hdac12.Init.DIV = 0;
	    hdac12.Init.EXTRef = DAC_EXTREF_OFF;    /* Выбор источника опорного напряжения: «1» - внешний; «0» - встроенный */
	    hdac12.Init.EXTClb = DAC_EXTCLB_DACREF; /* Выбор источника внешнего опорного напряжения: «1» - внешний вывод; «0» - настраиваемый ОИН */
	
	    HAL_DAC_Init(&hdac12);
	#else
	#endif
}
static void DAC12_cfunc(DAC12_cfunc_symbols_t * cfunc_symbols) {
	uint8_t seq_in1_1 = cfunc_symbols->seq_in1_1;
	uint16_t dac_value = cfunc_symbols->dac_value;
	/* Этот код вызывается на каждом шаге расчета модели */
	#ifdef MIK32V2
	    HAL_DAC_SetValue(&hdac12, dac_value);
	#else
	#endif
}

static void DAC12_cfunc_term() {
	/* Этот код вызывается один раз при остановке модели */
	#ifdef MIK32V2
	#else
	#endif
}
void scndderivd_d(const double *x, const double *y, uint32_t n, double *u, double *y2) {
	double p, qn, sig, un;
	uint32_t n1 = n - 1;
	y2[0] = 0.0;
	u[0] = 0.0;
	for (uint32_t i = 1; i < n1; i++) {
		double dxm1 = x[i] - x[i - 1];
		double dxp1 = x[i + 1] - x[i];
		double dxpm = dxp1 + dxm1;
		sig = dxm1 / dxpm;
		p = (sig * y2[i - 1]) + 2.0;
		y2[i] = (sig - 1.0) / p;
		u[i] = ((y[i + 1] - y[i]) / dxp1) - ((y[i] - y[i - 1]) / dxm1);
		u[i] = (((6.0 * u[i]) / dxpm) - (sig * u[i - 1])) / p;
	}
	qn = 0.0;
	un = 0.0;
	y2[n1] = (un - (qn * u[n1 - 1])) / ((qn * y2[n1 - 1]) + 1.0);
	for (uint32_t i = n1; i > 0; i--) {
		y2[i - 1] = (y2[i - 1] * y2[i]) + u[ i - 1];
	}
}

double look_d64d_binlpslin_1d(const double* uSet, const double** bpSet, const double* table, uint32_t* max) {
	double frac;
	uint32_t index;
	uint32_t left;
	uint32_t right;
	double table_value[1];

	for (int i = 0; i < 1; i++) {
		const double* bp = bpSet[i];
		const double u = uSet[i];
		if (u <= bp[0]) {
			left = 0;
			frac = (u - bp[0]) / (bp[1] - bp[0]);
		} else if (u < bp[max[i]]) {
			index = max[i] / 2;
			left = 0;
			right = max[i];
			while (right - left > 1) {
				if (u < bp[index]) {
					right = index;
				} else {
					left = index;
				}
				index = (right + left) / 2;
			}
			frac = (u - bp[left]) / (bp[left + 1] - bp[left]);
		} else {
			left = max[i] - 1;
			frac = (u - bp[max[i] - 1]) / (bp[max[i]] - bp[max[i] - 1]);
		}
	}

	table_value[0] = table[left];
	return (table[left + 1] - table_value[0]) * frac + table_value[0];
}

double look_d64d_binlpsclip_1d(const double* uSet, const double** bpSet, const double* table, uint32_t* max) {
	double frac;
	uint32_t index;
	uint32_t left;
	uint32_t right;
	double table_value[1];

	for (int i = 0; i < 1; i++) {
		const double* bp = bpSet[i];
		const double u = uSet[i];
		if (u <= bp[0]) {
			left = 0;
			frac = 0;
		} else if (u < bp[max[i]]) {
			index = max[i] / 2;
			left = 0;
			right = max[i];
			while (right - left > 1) {
				if (u < bp[index]) {
					right = index;
				} else {
					left = index;
				}
				index = (right + left) / 2;
			}
			frac = (u - bp[left]) / (bp[left + 1] - bp[left]);
		} else {
			left = max[i] - 1;
			frac = 1;
		}
	}

	table_value[0] = table[left];
	return (table[left + 1] - table_value[0]) * frac + table_value[0];
}


/* Model initialize function */
void mik32_fuzzy_reg_init() {
	systemClockConfig_cfunc_init();
	/* InitializeConditions for UnitDelay: /x2_data/LimitedCounter/UnitDelay */
	mik32_fuzzy_reg_S.UnitDelay_state = 0.0;
	/* InitializeConditions for UnitDelay: /x1_data/LimitedCounter/UnitDelay */
	mik32_fuzzy_reg_S.UnitDelay_1_state = 0.0;
	DAC12_cfunc_init();
}

/* Model terminate function */
void mik32_fuzzy_reg_term() {
	systemClockConfig_cfunc_term();
	DAC12_cfunc_term();
}

/* Model step function */
void mik32_fuzzy_reg_step() {
	static const double Vector[21] = {-2.0, -1.8, -1.6, -1.4, -1.2, -1.0, -0.8, -0.6, -0.4, -0.2, 0.0, 0.2, 0.4, 0.6, 0.8, 1.0, 1.2, 1.4, 1.6, 1.8, 2.0};
	static const double Vector_1[105] = {-2.0, -1.9615384615384615, -1.9230769230769231, -1.8846153846153846, -1.8461538461538463, -1.8076923076923077, -1.7692307692307692, -1.7307692307692308, -1.6923076923076923, -1.6538461538461537, -1.6153846153846154, -1.5769230769230769, -1.5384615384615385, -1.5, -1.4615384615384615, -1.4230769230769231, -1.3846153846153846, -1.3461538461538463, -1.3076923076923077, -1.2692307692307692, -1.2307692307692308, -1.1923076923076923, -1.1538461538461537, -1.1153846153846154, -1.0769230769230769, -1.0384615384615385, -1.0, -0.9615384615384616, -0.9230769230769231, -0.8846153846153846, -0.8461538461538461, -0.8076923076923077, -0.7692307692307693, -0.7307692307692307, -0.6923076923076923, -0.6538461538461539, -0.6153846153846154, -0.5769230769230769, -0.5384615384615384, -0.5, -0.46153846153846156, -0.4230769230769231, -0.38461538461538464, -0.34615384615384615, -0.3076923076923077, -0.2692307692307692, -0.23076923076923078, -0.19230769230769232, -0.15384615384615385, -0.11538461538461539, -0.07692307692307693, -0.038461538461538464, 0.0, 0.038461538461538464, 0.07692307692307693, 0.11538461538461539, 0.15384615384615385, 0.19230769230769232, 0.23076923076923078, 0.2692307692307692, 0.3076923076923077, 0.34615384615384615, 0.38461538461538464, 0.4230769230769231, 0.46153846153846156, 0.5, 0.5384615384615384, 0.5769230769230769, 0.6153846153846154, 0.6538461538461539, 0.6923076923076923, 0.7307692307692307, 0.7692307692307693, 0.8076923076923077, 0.8461538461538461, 0.8846153846153846, 0.9230769230769231, 0.9615384615384616, 1.0, 1.0384615384615385, 1.0769230769230769, 1.1153846153846154, 1.1538461538461537, 1.1923076923076923, 1.2307692307692308, 1.2692307692307692, 1.3076923076923077, 1.3461538461538463, 1.3846153846153846, 1.4230769230769231, 1.4615384615384615, 1.5, 1.5384615384615385, 1.5769230769230769, 1.6153846153846154, 1.6538461538461537, 1.6923076923076923, 1.7307692307692308, 1.7692307692307692, 1.8076923076923077, 1.8461538461538463, 1.8846153846153846, 1.9230769230769231, 1.9615384615384615, 2.0};
	uint8_t UnitDelay;
	uint8_t UnitDelay_1;
	double Output;
	double Output_1;
	uint8_t Sum;
	uint8_t Sum_1;
	uint8_t Switch;
	uint8_t Switch_1;
	double LARGE_1;
	double LARGE_1_breakpoints[] = {-2.0, -1.0, 0.0, 1.0, 2.0};
	const double* LARGE_1_breakpoint_set[] = {LARGE_1_breakpoints};
	uint32_t LARGE_1_max[] = {4};
	double LARGE_1_table[] = {0.0, 0.0, 0.0, 1.0, 1.0};
	double LARGE_2;
	double LARGE_2_breakpoints[] = {-2.0, -1.0, 0.0, 1.0, 2.0};
	const double* LARGE_2_breakpoint_set[] = {LARGE_2_breakpoints};
	uint32_t LARGE_2_max[] = {4};
	double LARGE_2_table[] = {0.0, 0.0, 0.0, 1.0, 1.0};
	double MEDIUM_1;
	double MEDIUM_1_breakpoints[] = {-2.0, -1.0, 0.0, 1.0, 2.0};
	const double* MEDIUM_1_breakpoint_set[] = {MEDIUM_1_breakpoints};
	uint32_t MEDIUM_1_max[] = {4};
	double MEDIUM_1_table[] = {0.0, 0.0, 1.0, 0.0, 0.0};
	double MEDIUM_2;
	double MEDIUM_2_breakpoints[] = {-2.0, -1.0, 0.0, 1.0, 2.0};
	const double* MEDIUM_2_breakpoint_set[] = {MEDIUM_2_breakpoints};
	uint32_t MEDIUM_2_max[] = {4};
	double MEDIUM_2_table[] = {0.0, 0.0, 1.0, 0.0, 0.0};
	double SMALL_2;
	double SMALL_2_breakpoints[] = {-2.0, -1.0, 0.0, 1.0, 2.0};
	const double* SMALL_2_breakpoint_set[] = {SMALL_2_breakpoints};
	uint32_t SMALL_2_max[] = {4};
	double SMALL_2_table[] = {1.0, 1.0, 0.0, 0.0, 0.0};
	double SMALL_1;
	double SMALL_1_breakpoints[] = {-2.0, -1.0, 0.0, 1.0, 2.0};
	const double* SMALL_1_breakpoint_set[] = {SMALL_1_breakpoints};
	uint32_t SMALL_1_max[] = {4};
	double SMALL_1_table[] = {1.0, 1.0, 0.0, 0.0, 0.0};
	double mu_SS;
	double mu_SM;
	double mu_SL;
	double mu_MS;
	double mu_MM;
	double mu_ML;
	double mu_LS;
	double mu_LM;
	double mu_LL;
	double L;
	double M;
	double S;
	double y_S;
	double y_M;
	double y_L;
	double Add_1;
	double Add;
	double offset;
	uint16_t scaling;
	uint16_t saturation;
	uint16_t data_type_conversion;

	/* Output for UnitDelay: /x2_data/LimitedCounter/UnitDelay */
	UnitDelay = mik32_fuzzy_reg_S.UnitDelay_state;
	/* Output for UnitDelay: /x1_data/LimitedCounter/UnitDelay */
	UnitDelay_1 = mik32_fuzzy_reg_S.UnitDelay_1_state;
	/* CFunction: /systemClockConfig incorporates:
	 */
	systemClockConfig_cfunc_symbols_t systemClockConfig_cfunc_symbols = {
	};
	systemClockConfig_cfunc(&systemClockConfig_cfunc_symbols);
	/* MultiPortSwitch: /x2_data/Output incorporates:
	 *  UnitDelay: /x2_data/LimitedCounter/UnitDelay
	 *  Constant: /x2_data/Vector
	 */
	Output = Vector[(int32_t)UnitDelay];
	/* MultiPortSwitch: /x1_data/Output incorporates:
	 *  UnitDelay: /x1_data/LimitedCounter/UnitDelay
	 *  Constant: /x1_data/Vector
	 */
	Output_1 = Vector_1[(int32_t)UnitDelay_1];
	/* Sum: /x1_data/LimitedCounter/Increment Real-World Value/Sum incorporates:
	 *  UnitDelay: /x1_data/LimitedCounter/UnitDelay
	 *  Constant: /x1_data/LimitedCounter/Increment Real-World Value/Constant
	 */
	Sum = UnitDelay_1 + 1;
	/* Sum: /x2_data/LimitedCounter/Increment Real-World Value/Sum incorporates:
	 *  UnitDelay: /x2_data/LimitedCounter/UnitDelay
	 *  Constant: /x2_data/LimitedCounter/Increment Real-World Value/Constant
	 */
	Sum_1 = UnitDelay + 1;
	/* Switch: /x1_data/LimitedCounter/Wrap To Zero/Switch incorporates:
	 *  Constant: /x1_data/LimitedCounter/Wrap To Zero/Initial Condition
	 *  Sum: /x1_data/LimitedCounter/Increment Real-World Value/Sum
	 *  Sum: /x1_data/LimitedCounter/Increment Real-World Value/Sum
	 */
	if (Sum > 104) {
		Switch = 0;
	} else {
		Switch = Sum;
	}
	/* End of Switch: /x1_data/LimitedCounter/Wrap To Zero/Switch */
	/* Switch: /x2_data/LimitedCounter/Wrap To Zero/Switch incorporates:
	 *  Constant: /x2_data/LimitedCounter/Wrap To Zero/Initial Condition
	 *  Sum: /x2_data/LimitedCounter/Increment Real-World Value/Sum
	 *  Sum: /x2_data/LimitedCounter/Increment Real-World Value/Sum
	 */
	if (Sum_1 > 20) {
		Switch_1 = 0;
	} else {
		Switch_1 = Sum_1;
	}
	/* End of Switch: /x2_data/LimitedCounter/Wrap To Zero/Switch */
	/* Lookup_n-D: /fuzzy_controller/fuzzyfication_1/LARGE_1 incorporates:
	 *  MultiPortSwitch: /x1_data/Output
	 */
	const double LARGE_1_u_set[] = {Output_1};
	LARGE_1 = look_d64d_binlpslin_1d(LARGE_1_u_set, LARGE_1_breakpoint_set, LARGE_1_table, LARGE_1_max);
	/* Lookup_n-D: /fuzzy_controller/fuzzyfication_2/LARGE_2 incorporates:
	 *  MultiPortSwitch: /x2_data/Output
	 */
	const double LARGE_2_u_set[] = {Output};
	LARGE_2 = look_d64d_binlpslin_1d(LARGE_2_u_set, LARGE_2_breakpoint_set, LARGE_2_table, LARGE_2_max);
	/* Lookup_n-D: /fuzzy_controller/fuzzyfication_1/MEDIUM_1 incorporates:
	 *  MultiPortSwitch: /x1_data/Output
	 */
	const double MEDIUM_1_u_set[] = {Output_1};
	MEDIUM_1 = look_d64d_binlpslin_1d(MEDIUM_1_u_set, MEDIUM_1_breakpoint_set, MEDIUM_1_table, MEDIUM_1_max);
	/* Lookup_n-D: /fuzzy_controller/fuzzyfication_2/MEDIUM_2 incorporates:
	 *  MultiPortSwitch: /x2_data/Output
	 */
	const double MEDIUM_2_u_set[] = {Output};
	MEDIUM_2 = look_d64d_binlpslin_1d(MEDIUM_2_u_set, MEDIUM_2_breakpoint_set, MEDIUM_2_table, MEDIUM_2_max);
	/* Lookup_n-D: /fuzzy_controller/fuzzyfication_2/SMALL_2 incorporates:
	 *  MultiPortSwitch: /x2_data/Output
	 */
	const double SMALL_2_u_set[] = {Output};
	SMALL_2 = look_d64d_binlpsclip_1d(SMALL_2_u_set, SMALL_2_breakpoint_set, SMALL_2_table, SMALL_2_max);
	/* Lookup_n-D: /fuzzy_controller/fuzzyfication_1/SMALL_1 incorporates:
	 *  MultiPortSwitch: /x1_data/Output
	 */
	const double SMALL_1_u_set[] = {Output_1};
	SMALL_1 = look_d64d_binlpsclip_1d(SMALL_1_u_set, SMALL_1_breakpoint_set, SMALL_1_table, SMALL_1_max);
	/* Mux: /fuzzy_controller/fuzzyfication_2/Mux incorporates:
	 *  Lookup_n-D: /fuzzy_controller/fuzzyfication_2/SMALL_2
	 *  Lookup_n-D: /fuzzy_controller/fuzzyfication_2/MEDIUM_2
	 *  Lookup_n-D: /fuzzy_controller/fuzzyfication_2/LARGE_2
	 */
	static double Mux[3];
	{	int j = 0;
		Mux[j++] = SMALL_2;
		Mux[j++] = MEDIUM_2;
		Mux[j++] = LARGE_2;
	}
	/* Mux: /fuzzy_controller/fuzzyfication_1/Mux incorporates:
	 *  Lookup_n-D: /fuzzy_controller/fuzzyfication_1/SMALL_1
	 *  Lookup_n-D: /fuzzy_controller/fuzzyfication_1/MEDIUM_1
	 *  Lookup_n-D: /fuzzy_controller/fuzzyfication_1/LARGE_1
	 */
	static double Mux_1[3];
	{	int j = 0;
		Mux_1[j++] = SMALL_1;
		Mux_1[j++] = MEDIUM_1;
		Mux_1[j++] = LARGE_1;
	}
	const double Demux = Mux_1[0];
	const double Demux_p1 = Mux_1[1];
	const double Demux_p2 = Mux_1[2];
	const double Demux_1 = Mux[0];
	const double Demux_1_p1 = Mux[1];
	const double Demux_1_p2 = Mux[2];
	/* MinMax: /fuzzy_controller/activation/MinMax incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_SS = fmin(Demux, Demux_1);
	/* MinMax: /fuzzy_controller/activation/MinMax-1 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_SM = fmin(Demux, Demux_1_p1);
	/* MinMax: /fuzzy_controller/activation/MinMax-2 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_SL = fmin(Demux, Demux_1_p2);
	/* MinMax: /fuzzy_controller/activation/MinMax-3 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_MS = fmin(Demux_p1, Demux_1);
	/* MinMax: /fuzzy_controller/activation/MinMax-4 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_MM = fmin(Demux_p1, Demux_1_p1);
	/* MinMax: /fuzzy_controller/activation/MinMax-5 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_ML = fmin(Demux_p1, Demux_1_p2);
	/* MinMax: /fuzzy_controller/activation/MinMax-6 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_LS = fmin(Demux_p2, Demux_1);
	/* MinMax: /fuzzy_controller/activation/MinMax-7 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_LM = fmin(Demux_p2, Demux_1_p1);
	/* MinMax: /fuzzy_controller/activation/MinMax-8 incorporates:
	 *  Demux: /fuzzy_controller/activation/Demux
	 *  Demux: /fuzzy_controller/activation/Demux-1
	 */
	mu_LL = fmin(Demux_p2, Demux_1_p2);
	/* Mux: /fuzzy_controller/activation/Mux incorporates:
	 *  MinMax: /fuzzy_controller/activation/MinMax
	 *  MinMax: /fuzzy_controller/activation/MinMax-1
	 *  MinMax: /fuzzy_controller/activation/MinMax-2
	 *  MinMax: /fuzzy_controller/activation/MinMax-3
	 *  MinMax: /fuzzy_controller/activation/MinMax-4
	 *  MinMax: /fuzzy_controller/activation/MinMax-5
	 *  MinMax: /fuzzy_controller/activation/MinMax-6
	 *  MinMax: /fuzzy_controller/activation/MinMax-7
	 *  MinMax: /fuzzy_controller/activation/MinMax-8
	 */
	static double Mux_2[9];
	{	int j = 0;
		Mux_2[j++] = mu_SS;
		Mux_2[j++] = mu_SM;
		Mux_2[j++] = mu_SL;
		Mux_2[j++] = mu_MS;
		Mux_2[j++] = mu_MM;
		Mux_2[j++] = mu_ML;
		Mux_2[j++] = mu_LS;
		Mux_2[j++] = mu_LM;
		Mux_2[j++] = mu_LL;
	}
	const double Demux_1_1 = Mux_2[0];
	const double Demux_1_1_p1 = Mux_2[1];
	const double Demux_1_1_p2 = Mux_2[2];
	const double Demux_1_1_p3 = Mux_2[3];
	const double Demux_1_1_p4 = Mux_2[4];
	const double Demux_1_1_p5 = Mux_2[5];
	const double Demux_1_1_p6 = Mux_2[6];
	const double Demux_1_1_p7 = Mux_2[7];
	const double Demux_1_1_p8 = Mux_2[8];
	/* MinMax: /fuzzy_controller/accumulation/L incorporates:
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 */
	L = fmax(fmax(Demux_1_1_p5, Demux_1_1_p7), Demux_1_1_p8);
	/* MinMax: /fuzzy_controller/accumulation/M incorporates:
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 */
	M = fmax(fmax(fmax(Demux_1_1_p1, Demux_1_1_p2), Demux_1_1_p4), Demux_1_1_p6);
	/* MinMax: /fuzzy_controller/accumulation/S incorporates:
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 *  Demux: /fuzzy_controller/accumulation/Demux
	 */
	S = fmax(Demux_1_1, Demux_1_1_p3);
	/* Gain: /fuzzy_controller/defuzzyfication/y_S incorporates:
	 *  MinMax: /fuzzy_controller/accumulation/S
	 */
	y_S = -1 * S;
	/* Gain: /fuzzy_controller/defuzzyfication/y_M incorporates:
	 *  MinMax: /fuzzy_controller/accumulation/M
	 */
	y_M = 0 * M;
	/* Gain: /fuzzy_controller/defuzzyfication/y_L incorporates:
	 *  MinMax: /fuzzy_controller/accumulation/L
	 */
	y_L = 1 * L;
	/* Sum: /fuzzy_controller/defuzzyfication/Add-1 incorporates:
	 *  MinMax: /fuzzy_controller/accumulation/S
	 *  MinMax: /fuzzy_controller/accumulation/M
	 *  MinMax: /fuzzy_controller/accumulation/L
	 */
	Add_1 = S + M + L;
	/* Sum: /fuzzy_controller/defuzzyfication/Add incorporates:
	 *  Gain: /fuzzy_controller/defuzzyfication/y_S
	 *  Gain: /fuzzy_controller/defuzzyfication/y_M
	 *  Gain: /fuzzy_controller/defuzzyfication/y_L
	 */
	Add = y_S + y_M + y_L;
	/* Product: /fuzzy_controller/defuzzyfication/Divide incorporates:
	 *  Sum: /fuzzy_controller/defuzzyfication/Add
	 *  Sum: /fuzzy_controller/defuzzyfication/Add-1
	 */
	const double Divide = Add / Add_1;
	/* /fuzzy_controller/defuzzyfication_terminator_p1 is eliminated */
	/* Bias: /scaling/offset incorporates:
	 *  Sum: /fuzzy_controller/defuzzyfication/Add
	 */
	offset = Add + 1;
	/* Gain: /scaling/scaling incorporates:
	 *  Bias: /scaling/offset
	 */
	scaling = 2048 * offset;
	/* Saturate: /scaling/saturation incorporates:
	 *  Gain: /scaling/scaling
	 */
	if (scaling < 0) {
		saturation = 0;
	} else if (scaling > 4095) {
		saturation = 4095;
	} else {
		saturation = scaling;
	}
	/* DataTypeConversion: /scaling/data_type_conversion incorporates:
	 *  Saturate: /scaling/saturation
	 */
	data_type_conversion = (uint16_t)saturation;
	/* CFunction: /DAC12 incorporates:
	 *  CFunction: /systemClockConfig
	 *  DataTypeConversion: /scaling/data_type_conversion
	 */
	DAC12_cfunc_symbols_t DAC12_cfunc_symbols = {
		systemClockConfig_cfunc_symbols.seq_out1,
		data_type_conversion,
	};
	DAC12_cfunc(&DAC12_cfunc_symbols);
	/* Update for UnitDelay: /x2_data/LimitedCounter/UnitDelay */
	mik32_fuzzy_reg_S.UnitDelay_state = Switch_1;
	/* Update for UnitDelay: /x1_data/LimitedCounter/UnitDelay */
	mik32_fuzzy_reg_S.UnitDelay_1_state = Switch;

}
